Compare commits

...

16 Commits

Author SHA1 Message Date
Jack L. Frost 4939405926 ABS is not using SVN anymore
Signed-off-by: fbt <fbt@fleshless.org>
2023-10-26 14:54:30 +00:00
Jack L. Frost e9bdb6b4e1 rpc url
Signed-off-by: fbt <fbt@fleshless.org>
2022-02-14 22:20:00 +03:00
Jack L. Frost df42e43a49 just create the dir 2016-04-01 13:19:52 +03:00
Jack L. Frost 7fedda7342 Should probably feed pacman the package name
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-17 02:29:43 +03:00
Alad Wenter cdc83819f5 Use pacman -Sp for figuring out the repo a package is in
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-17 02:27:46 +03:00
Alad Wenter 96b7584153 Use one jshon call for search results
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-17 02:25:32 +03:00
Jack L. Frost aacf420a68 There is no more tarball
Signed-off-by: fbt <fbt@fleshless.org>
2016-03-01 08:32:19 +03:00
Alad Wenter 56a2817649 Fix jshon calls
Signed-off-by: fbt <fbt@fleshless.org>
2016-02-29 18:49:49 +03:00
Alad Wenter 97d6852e92 Use RPC v5
Signed-off-by: fbt <fbt@fleshless.org>
2016-02-29 18:41:08 +03:00
Jack L. Frost 04ec3a81a5 README also 2015-09-25 18:15:58 +03:00
Jack L. Frost 8db246e7af help update 2015-09-25 18:14:45 +03:00
Jack L. Frost c13a3a3fdc support for downloading updated packages 2015-09-25 18:12:04 +03:00
Jack L. Frost 0b62cf2bc4 Don't query AUR for each package dammit 2015-09-25 17:56:23 +03:00
Jack L. Frost 351a03c515 update! 2015-09-23 18:05:45 +03:00
Jack L. Frost 8e2ed7b9f9 Update usage and README 2015-09-21 14:18:24 +03:00
Jack L. Frost e7252333b0 A few improvements:
* Use the new RPC format to avoid sourcing the PKGBUILD.
* A separate switch for curl's insecure mode: --nossl.
* Clone the AUR git repos instead of downloading the targballs.
2015-09-21 14:14:54 +03:00
2 changed files with 131 additions and 76 deletions

View File

@ -9,8 +9,11 @@ A very simple AUR/ABS helper. Doesn't build packages, only gets the sources.
-S Search only in the sync db. Implies -s.
-A Search only in AUR. Implies -s.
-d Get the package sources (default). Set twice to also get the dependencies.
-f Force downloading package sources even if they are already present in the working directory.
-n Don't update existing git repos.
-u Print out all (and download if -d/-dd) outdated AUR packages.
-U <url> Set AUR url.
-w <dir> Set the working directory.
--nossl Set curl's --insecure flag.
You can override any value in the script in \$HOME/.config/prm.rc.sh
By default prm downloads the sources into the current directory. Controlled by `$cfg_workdir`.

202
prm
View File

@ -8,6 +8,8 @@ _self="${0##*/}"
cfg_workdir="$PWD"
cfg_aur_url="https://aur.archlinux.org"
cfg_curl_opts=( '--silent' '--location' )
err() { printf "$@" >&2; }
_cat() { while read -r; do printf '%s\n' "$REPLY"; done }
@ -21,38 +23,36 @@ usage() {
-S Search only in the sync db. Implies -s.
-A Search only in AUR. Implies -s.
-d Get the package sources (default). Set twice to also get the dependencies.
-f Force downloading package sources even if they are already present in the working directory.
-n Don't update existing git repos.
-u Print out all (and download if -d/-dd) outdated AUR packages.
-U <url> Set AUR url.
-w <dir> Set the working directory.
--nossl Set curl's --insecure flag.
EOF
}
aur.search() {
declare i aur_api_search_data aur_search_result_num aur_search_results version description
declare i aur_api_search_data aur_search_result_num version description
aur_api_search_data=$( curl -skL "${cfg_aur_api}?type=search&arg=${1}" )
aur_api_search_data=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=search&arg=${1}" )
aur_search_result_num=$( jshon -e resultcount -u <<< "$aur_api_search_data" )
# Exit if nothing was found
(( aur_search_result_num )) || { return 1; }
aur_search_results=( $( jshon -e results -a -e Name -u <<< "$aur_api_search_data" ) )
for i in "${!aur_search_results[@]}"; do
{
read -r version
read -r description
} < <(
jshon -e results -e $i -e Version -u -p -e Description -u <<< "$aur_api_search_data"
)
printf '%s %s\n %s\n' "aur/${aur_search_results[$i]}" "$version" "$description"
done
while {
read -r name
read -r version
read -r description
} do
printf '%s %s\n %s\n' "aur/$name" "$version" "$description"
done < <( jshon -C -e results -a -e Name -u -p -e Version -u -p -e Description -u <<< "$aur_api_search_data" )
}
aur.info() {
declare pkg_aur_info aur_query_result
pkg_aur_info=$( curl -skL "${cfg_aur_api}?type=info&arg=${1}" 2>/dev/null )
pkg_aur_info=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=info&arg=${1}" 2>/dev/null )
aur_query_result=$( jshon -e resultcount -u <<< "$pkg_aur_info" )
(( aur_query_result )) || { return 1; }
@ -60,42 +60,85 @@ aur.info() {
printf '%s' "$pkg_aur_info"
}
aur.get_updates() {
declare -a foreign_packages updated_pkgs
declare aur_api_multireq aur_api_data aur_api_data_length n p u n_name n_version l_name l_version
read -d '' -r -a foreign_packages < <( pacman -Qqm )
for p in "${foreign_packages[@]}"; do
aur_api_multireq+="&arg\[\]=$p"
done
aur_api_data=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=info${aur_api_multireq}" )
aur_api_data_length=$( jshon -e results -l <<< "$aur_api_data" )
(( aur_api_data_length-- ))
for (( n=0; n<=aur_api_data_length; n++ )); do
read -r n_name < <( jshon -e results -e "$n" -e Name -u <<< "$aur_api_data")
read -r n_version < <( jshon -e results -e "$n" -e Version -u <<< "$aur_api_data" )
read -r l_name l_version < <( pacman -Q "$n_name" )
if (( $(vercmp "$n_version" "$l_version") )); then
updated_pkgs+=( "$n_name" )
printf '%s\n' "$n_name"
fi
done
if ! (( ${#updated_pkgs[@]} )); then
printf 'No updates found\n'
return 0
fi
if (( flag_get )); then
for u in "${updated_pkgs[@]}"; do
aur.get < <( aur.info "$u" )
done
fi
}
aur.get() {
declare i pkg_aur_info pkg_base tarball_path depends makedepends dep_name aur_api_multireq dep_name aur_deps_api_data aur_deps_count aur_deps
declare i pkg_aur_info pkg_base depends makedepends dep_name aur_api_multireq dep_name aur_deps_api_data aur_deps_count aur_deps
read -r pkg_aur_info
# A temporary hack till AUR4 becomes the main version
read -r pkg_base < <( jshon -e results -e PackageBase -u <<< "$pkg_aur_info" )
tarball_path="/cgit/aur.git/snapshot/${pkg_base}.tar.gz"
(( flag_force )) || {
[[ -d "${cfg_workdir}/${pkg_base}" ]] && {
printf "Found %s in %s, skipping. Use -f to override\n" "${pkg_base}" "${cfg_workdir}"
return 17
}
}
read -r pkg_base < <( jshon -e results -a -e Name -u <<< "$pkg_aur_info" )
cd "$cfg_workdir"
printf 'Working in %s\n' "${cfg_workdir}"
printf "Working in %s\n" "${cfg_workdir}"
printf "Downloading %s\n" "${pkg_base}"
{ curl -skL "${cfg_aur_url}${tarball_path}" | gzip -d | tar x; } || {
err "Fail!\n"
return 1
}
if [[ -d "$pkg_base" ]]; then
if ! (( flag_nopull )); then
printf 'Updating %s\n' "$pkg_base"
cd "$pkg_base"
git pull || {
err 'Fail!'
return 21
}
fi
else
printf 'Cloning %s\n' "$pkg_base"
git clone "https://aur.archlinux.org/${pkg_base}.git" || {
err 'Fail!'
return 19
}
fi
if (( flag_get_deps )); then
cd "${cfg_workdir}/${pkg_base}"
source PKGBUILD
for i in "${depends[@]}" "${makedepends[@]}"; do
read -d '' -r -a depends < <(
jshon -Q -e results -a -e Depends -a -u <<< "$pkg_aur_info"
jshon -Q -e results -a -e MakeDepends -a -u <<< "$pkg_aur_info"
)
for i in "${depends[@]}"; do
dep_name="${i/[<>=]*}"
aur_api_multireq+="&arg\[\]=$dep_name"
done
aur_deps_api_data=$( curl -skL "${cfg_aur_api}?type=multiinfo${aur_api_multireq}" )
aur_deps_api_data=$( curl "${cfg_curl_opts[@]}" "${cfg_aur_api}&type=info${aur_api_multireq}" )
aur_deps_count=$( jshon -e resultcount <<< "$aur_deps_api_data" )
if (( aur_deps_count )); then
@ -107,27 +150,16 @@ aur.get() {
aur.get < <(aur.info "$i")
_result="$?"
(( _result > 0 && result != 17 )) && {
if (( _result > 0 && result != 17 )); then
return "$_result"
}
fi
done
fi
fi
}
abs.get() {
declare pkg_repo svn_repo
pkg_repo="$2"
case "$pkg_repo" in
(community|multilib)
svn_repo='community';;
(*)
svn_repo='packages';;
esac
svn export "svn://svn.archlinux.org/${svn_repo}/${1}/trunk" "${cfg_workdir}/${1}"
git clone "https://gitlab.archlinux.org/archlinux/packaging/packages/$1.git" "$cfg_workdir/$1"
}
set_argv() {
@ -176,23 +208,26 @@ main() {
(-h) usage; return 0;;
(-s) action='search';;
(-s) flag_search=1;;
(-A)
action='search'
flag_search=1
flag_search_aur=1;;
(-S)
action='search'
flag_search=1
flag_search_syncdb=1;;
(-u)
(-U)
cfg_aur_url="$2"
shift;;
(-u)
flag_update=1;;
(-d)
if [[ "$action" == 'get' ]]; then
if (( flag_get )); then
flag_get_deps=1
else
action='get'
flag_get=1
fi
;;
@ -200,7 +235,9 @@ main() {
cfg_workdir="$2"
shift;;
(-f) flag_force=1;;
(-n) flag_nopull=1;;
(--nossl) cfg_curl_opts+=( '--insecure' );;
(-*)
err "Unknown key: %s\n" "$1"
@ -217,27 +254,37 @@ main() {
unset flag_search_aur flag_search_syncdb
}
cfg_aur_api="${cfg_aur_url}/rpc.php"
cfg_aur_api="${cfg_aur_url}/rpc?v=5"
if (( flag_search )); then
action=search
elif (( flag_update )); then
action=update
elif (( flag_get )); then
action=get
fi
if [[ "$1" ]]; then
package="$1"
fi
[[ "$action" ]] || {
usage
return 1
}
if [[ "$1" ]]; then
package="$1"
else
usage
return 1
fi
[[ -d "$cfg_workdir" ]] || {
mkdir -p "$cfg_workdir" || {
err "Can't create workdir: %s\n" "$cfg_workdir"
return 1
}
}
case "$action" in
(get)
[[ -d "$cfg_workdir" ]] || {
mkdir -p "$cfg_workdir" || {
err "Can't create workdir: %s\n" "$cfg_workdir"
return 1
}
[[ "$package" ]] || {
usage
return 1
}
pkg_aur_info=$( aur.info "$package" )
@ -245,11 +292,7 @@ main() {
if (( ! "$?" )); then
repo='aur'
else
while read -r; do
if [[ "$REPLY" =~ ^Repository ]]; then
repo="${REPLY##* }"
fi
done < <( pacman -Si "$package" )
read -r repo < <( pacman -Sp --print-format '%r' "$package" )
[[ "$repo" ]] || {
err "Can't find package %s\n" "$package"
@ -273,6 +316,11 @@ main() {
;;
(search)
[[ "$package" ]] || {
usage
return 1
}
if (( flag_search_aur )); then
aur.search "$package" || {
err "No packages found\n"
@ -290,6 +338,10 @@ main() {
fi
fi
;;
(update)
aur.get_updates
;;
esac
}